# -*- coding: utf-8 -*-
# Script para extrair fatias de imagens 4D e salvá-las
# como arquivos jpeg.
# Baseado nos exemplos do livro do Papademetris


# Adiciona ao 'autopath' o diretório do script
# atual
lappend auto_path [ file dirname [ info script ]]

puts $auto_path

# Minimiza a janela principal
# wm withdraw  .

package require loadbioimagesuite 1.0

if {$argc < 1} {
    puts "Usage:"
    # argv0 is the script name
    puts "$argv0 input_file"
} else {
    set inputfile [ lindex $argv 0 ]

    # Instancia o leitor de imagens formato Analyze
    set ana [ vtkpxAnalyzeImageSource [ pxvtable::vnewobj ]]
    $ana Load $inputfile

    set img [ $ana GetOutput ]
    set orient [ $ana GetOrientation ]
    puts stderr "Image Dimensions = [ $img GetDimensions ], Orientation = $orient"

    # Filtro especializado do Bioimagesuite que extrai
    # fatias de imagens 4d. Ver capítulo 15 do livro do
    # Papademetris
    set extr [vtkpxImageExtract  [ pxvtable::vnewobj] ]
    $extr SetInput $img
    # plano da fatia que vai ser extraída
    # YZ = 0
    # XZ = 1
    # XY = 2
    $extr SetCurrentPlane 2
    $extr SetSliceNo 10
    $extr SetFrame 0
    $extr Update

    # É preciso fazer um 'cast' porque a imagem original está
    # em formato 'int' e o jpeg requer 'unsigned char'
    set casttransf [vtkImageCast [ pxvtable::vnewobj ]]
    $casttransf SetOutputScalarTypeToUnsignedChar
    $casttransf SetInput [$extr GetOutput]
    $casttransf Update

    set writer [vtkJPEGWriter [pxvtable::vnewobj]]
    $writer SetFileDimensionality 2
    $writer SetFileName "slice0_10.jpg"
    $writer SetInput [$casttransf GetOutput]
    $writer Write

}

exit
