
#BIOIMAGESUITE_LICENSE  ---------------------------------------------------------------------------------
#BIOIMAGESUITE_LICENSE  This file is part of the BioImage Suite Software Package.
#BIOIMAGESUITE_LICENSE  
#BIOIMAGESUITE_LICENSE  X. Papademetris, M. Jackowski, N. Rajeevan, R.T. Constable, and L.H
#BIOIMAGESUITE_LICENSE  Staib. BioImage Suite: An integrated medical image analysis suite, Section
#BIOIMAGESUITE_LICENSE  of Bioimaging Sciences, Dept. of Diagnostic Radiology, Yale School of
#BIOIMAGESUITE_LICENSE  Medicine, http://www.bioimagesuite.org.
#BIOIMAGESUITE_LICENSE  
#BIOIMAGESUITE_LICENSE  This program is free software; you can redistribute it and/or
#BIOIMAGESUITE_LICENSE  modify it under the terms of the GNU General Public License version 2
#BIOIMAGESUITE_LICENSE  as published by the Free Software Foundation.
#BIOIMAGESUITE_LICENSE  
#BIOIMAGESUITE_LICENSE  This program is distributed in the hope that it will be useful,
#BIOIMAGESUITE_LICENSE  but WITHOUT ANY WARRANTY; without even the implied warranty of
#BIOIMAGESUITE_LICENSE  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#BIOIMAGESUITE_LICENSE  GNU General Public License for more details.
#BIOIMAGESUITE_LICENSE  
#BIOIMAGESUITE_LICENSE  You should have received a copy of the GNU General Public License
#BIOIMAGESUITE_LICENSE  along with this program; if not, write to the Free Software
#BIOIMAGESUITE_LICENSE  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#BIOIMAGESUITE_LICENSE  See also  http://www.gnu.org/licenses/gpl.html
#BIOIMAGESUITE_LICENSE  
#BIOIMAGESUITE_LICENSE  If this software is modified please retain this statement and add a notice
#BIOIMAGESUITE_LICENSE  that it had been modified (and by whom).  
#BIOIMAGESUITE_LICENSE  
#BIOIMAGESUITE_LICENSE  -----------------------------------------------------------------------------------



package provide vtkpxcontrib 1.2
package provide vtknrcontrib 1.2

# 	$Id: vtkpxcontrib.tcl,v 1.2 2005/12/01 16:42:14 xenios Exp xenios $	

lappend auto_path [ file dirname [ info script ]]
lappend auto_path [ file join [ file join [ file join  [ file dirname [ info script ]] .. ] extensions ] lib ]

package require pxtclutil

namespace eval ::pxtclvtkpxcontrib {

    variable osmode       unix
    variable libraryprefix     lib
    variable librarysuffix     .so
    variable librarypath       ""
    variable staticsuffix      .a
    variable execsuffix        ""
    variable baselibrarypath [ file join [ file join [ file dirname [ info script ]] .. ] lib ]
    variable vtkpxlibrarylist { vtkpxClosedTCL  vtkpxCommonTCL  vtkpxGraphicsTCL  vtkpxLegacyTCL  vtkpxImagingTCL  vtkpxRegistrationTCL  vtkpxSegmentationTCL  vtkpxNmrlibTCL vtkpxLevelsetTCL vtknrCommonTCL  vtknrGraphicsTCL vtknrImagingTCL vtknrNmrlibTCL }      
    variable vtkpxguilibrarylist { vtkpxGUITCL  Vtkpxtklib   }
    variable debugmode 0


    variable versionno  "2.0RC2"
    variable versiondate  "December 11, 2006"
    variable version  "BioImage Suite ${versionno} $versiondate"


    variable yalelogo  0
    variable logo      0  
    variable smalllogo 0
    variable fontname  0

    # -------------------------------------------------------------------------
    # Initialize Logos
    # -------------------------------------------------------------------------


    proc CheckForUpdates { } {

	set ok "yes"
	catch { 	set ok [ tk_messageBox -title "Checking for Updates" -type yesno  -message "May BioImage Suite phone home (connect to www.bioimagesuite.org) to check for updates?\n(This involves downloading the file http://www.bioimagesuite.org/VERSION.txt)"  ] }
	if { $ok == "no" } {
	    return -1 
	}
	
	set ver 0
	catch {
	    set ver [http::data [http::geturl "http://www.bioimagesuite.org/VERSION.txt" ]]
	}
	if { $ver == 0 } {
	    catch { tk_messageBox -type ok -message "Connection to www.bioimagesuite.org failed\n" -title "Connection Error!" }
	    return -1
	}
	
	if { $ver != $::pxtclvtkpxcontrib::version } {
	    catch { tk_messageBox -type ok -title "For your information ..." -icon info -message "A Newer version is available:\n$ver\nYour current version is\n$::pxtclvtkpxcontrib::version" }
	    return 0
	} 
	catch { tk_messageBox -type ok -title "For your information ..." -icon info -message "Your Version of BioImage Suite is up to date\n($::pxtclvtkpxcontrib::version)" }
	return 1

    }


    
    proc InitializeBioImageSuiteLogos { } {
	variable yalelogo  
	variable logo      
	variable smalllogo 
	variable fontname  
	
	catch {
	    variable logo [ image create photo -file [ file join [ file join [ file join [ file dirname [ info script ]] .. ] images ] bioimagesuite_logo_www.gif ] ]
	    variable smalllogo [ image create photo -file [ file join [ file join [ file join [ file dirname [ info script ]] .. ] images ] bioimagesuite_logo_small_www.gif ] ]

	    variable fontname { Helvetica 10 bold }
	}
    }

    # -------------------------------------------------------------------------

    proc CheckVisualStudioVersion { } {

	variable libraryprefix
	variable librarysuffix
	variable baselibrarypath
	variable librarypath
	variable debugmode
	variable osmode
	variable vtkpxlibrarylist

	set libraryname [ lindex $vtkpxlibrarylist 0 ]

	set path1    [ file join $baselibrarypath debug  ]
	set path2    [ file join $baselibrarypath release ]

  	set libname1 [ file join $path1 "${libraryprefix}${libraryname}${librarysuffix}" ]
	set libname2 [ file join $path2 "${libraryprefix}${libraryname}${librarysuffix}" ]

	set tm1 -1; catch { set tm1 [ file mtime $libname1 ] }
	set tm2 -1; catch { set tm2 [ file mtime $libname2 ] }

	if { $debugmode > 0 } {
	    puts stderr "File Times:\n\t $libname1 ($tm1)\n\t $libname2 ($tm2)"
	}

	if { $tm1 > $tm2 } {
	    return "debug"
	}

	return "release"
    }


    proc InitializePlatform { } {

	global tcl_platform
	variable osmode
	variable libraryprefix
	variable librarypath
	variable librarysuffix
	variable debugmode
	variable staticsuffix
	variable baselibrarypath
	variable execsuffix


	if { $tcl_platform(os) == "Darwin" } {
	    if { [ file dirname [ info nameofexecutable ] ] == "/usr/local/vtk44_carbon_yale/bin" } {
		set extraname "carbon"
		set osmode  macos
	    } else {
		set osmode macosx11
	    }
	    if { [ string first "enios"  $baselibrarypath  ] > 1 } {
		set debugmode 1
	    }

	} elseif { $tcl_platform(platform) == "windows" } { 
	    catch {
		set exename [ info nameofexecutable ]
		
		if { [ string first cygwin $exename ] > 0 } {
		    set osmode windowscygwin
		}
	    }
	    
	    if { $osmode != "windowscygwin" } {
		set osmode windows
	    }
	    set execsuffix ".exe"
	    if { [ string first "enios"  $baselibrarypath  ] > 1 } {
		set debugmode 1
	    }
	}

	switch -exact -- $osmode { 
	    "unix" {
		set libraryprefix "lib"
		set librarysuffix ".so"
		set librarypath    ""
	    }
	    "windowscygwin" {
		set libraryprefix "lib"
		set librarysuffix ".dll" 
		set librarypath "cygwin"
	    }
	    "windows" {
		set libraryprefix ""
		set librarysuffix ".dll" 
		set staticsuffix  ".lib"
		set librarypath [ CheckVisualStudioVersion ] 
		# test release vs debug
	    }
	    "macos" {
		set libraryprefix "lib"
		set librarysuffix ".dylib"
		set librarypath   "carbon"
	    } 
	    "macosx11" {
		set libraryprefix "lib"
		set librarysuffix ".dylib"
		set librarypath   ""
	    }
	}

	if { $debugmode > 0 } {
	    puts stderr "System: os=$osmode library  $librarypath, $libraryprefix , $librarysuffix (static=$staticsuffix)" 
	}

    }

    # -------------------------------------------------------------------------

    proc LoadVTKLibraries { } {

	global env
	global tcl_platform	
	global auto_path



	set fname [ string range [ file root [ file tail [ info nameofexecutable] ]] 0 2]
	
	if { $fname != "vtk"} {
	    if { $tcl_platform(platform) == "windows"} {
		set suffix ".exe"
		set divider ";"
	    } else {
		set suffix ""
		set divider ":"
	    }
	
	    set newpath "[ file dirname [ info nameofexecutable ]]${divider}$env(PATH)"

	    set plist [ split $newpath $divider ]
	    set ppath ""
	    set flag 0
	    set len [ llength $plist ]
	    set i 0
	    while { $i < $len && $flag == 0 } {
		set ppath [ lindex $plist $i ]
		
		if { [ file exists [ file join $ppath vtk$suffix ]] == 1 } {
		    set flag 1
		}
		incr i
	    }
	    
	    
	    if { $flag == 1 } {
		if { $tcl_platform(platform) == "windows"} {
		    lappend auto_path [ file join $ppath "../Wrapping/Tcl" ]
		}
		lappend auto_path [ file join $ppath "../lib/vtk/tcl" ]

		if { $fname == "tcl" } {
		    catch {		   
			package require vtkbase
			package require vtkcommon
			package require vtkfiltering
			package require vtkgraphics
			package require vtkhybrid
			package require vtkimaging
			package require vtkio
			package require vtkparallel
			package require vtkpatented
			package require vtkrendering
		    }
		} else {
		    package require vtk 4.4 
		}
	    } else {
		tk_messageBox -type ok -message "Cannot find vtk.exe in your path!     [ info nameofexecutable ]" -title "Error!" -icon error
		exit
	    }
	}
    }

    # -------------------------------------------------------------------------
    proc LoadLibrary { libraryname initialcommand } { 

	variable libraryprefix
	variable librarysuffix
	variable baselibrarypath
	variable librarypath
	variable debugmode
	variable osmode

	
	set path    [ file join $baselibrarypath $librarypath ]
	set libname [ file join $path "${libraryprefix}${libraryname}${librarysuffix}" ]

	if { [ file exists $libname ] } {
	    
	    if { $debugmode > 0 } {
		puts  stderr "Loading $osmode $libname"
	    }
	    if { $initialcommand == "" } {
		load $libname 
	    } else {
		load $libname $initialcommand 
	    }
	} else {
	    puts stderr "$libname does not exist"
	}
    }

    # -------------------------------------------------------------------------
    proc LoadGUILibraries { librarylist } {

	LoadLibrary [ lindex $librarylist 0 ] [ lindex $librarylist 1 ]
    }

    # -------------------------------------------------------------------------
    proc LoadLibraries { librarylist } {

	for { set i 0 } { $i < [ llength $librarylist ] } { incr i  } {
	    LoadLibrary [ lindex $librarylist $i ] ""
	}
    }
    # -------------------------------------------------------------------------
    proc LoadAll { } {

	variable vtkpxlibrarylist
	variable vtkpxguilibrarylist
	
	global vtkpxcontrib_no_gui
	LoadLibraries $vtkpxlibrarylist

	set dogui 1

	catch { 
	    if { $vtkpxcontrib_no_gui == 1 } {
		set dogui 0
	    }
	}

	if { $dogui == 1 } {
	    LoadGUILibraries $vtkpxguilibrarylist
	}
    }
    # -------------------------------------------------------------------------
}


::pxtclvtkpxcontrib::InitializePlatform
::pxtclvtkpxcontrib::InitializeBioImageSuiteLogos
 

set doload 1
catch { 
    if { $vtkpxcontrib_no_load == 1 } {
	set doload 0
    }
}

if { $doload == 1 } {
    ::pxtclvtkpxcontrib::LoadVTKLibraries
    ::pxtclvtkpxcontrib::LoadAll
}
unset doload

